﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace EventsTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            SimpleObjectAdded += new EventHandler<EventArgs_Generic<int>>
                    (Processor_SimpleObjectAdded);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {   
            EventArgExtensions.Raise(new EventArgs_Generic<int>(1), sender, ref SimpleObjectAdded);
        }

        public event EventHandler<EventArgs_Generic<int>> SimpleObjectAdded;
        void Processor_SimpleObjectAdded(object sender, EventArgs_Generic<int> e)
        {
            MessageBox.Show(e.TargetObject.ToString());
        }
    }

    public class EventArgs_object : EventArgs
    {
        public object Target;
        public EventArgs_object(object o)
        {
            Target = o;
        }
    }

    public class EventArgs_Generic<T> : EventArgs
    {
        public EventArgs_Generic(T Target)
        {
            _TargetObject = Target;
        }
        private T _TargetObject;
        public T TargetObject
        {
            get
            {
                return _TargetObject;
            }
            set
            {
                _TargetObject = value;
            }
        }
    }

    public static class EventArgExtensions
    {
        public static void Raise<TEventArgs>(this TEventArgs e, Object sender, ref EventHandler<TEventArgs> eventDelegate)
        {
            // Копируем ссылку на делегат во временную переменную, для потоковой безопасности 
            EventHandler<TEventArgs> temp = Volatile.Read(ref eventDelegate);

            // Если есть подписчики на это событие, уведомляем их  
            if (temp != null) temp(sender, e);
        }
    }
}
